searchNodes=[{"doc":"Defines a behaviour for higher-level password hashing functions.","ref":"Comeonin.html","title":"Comeonin","type":"behaviour"},{"doc":"Hashes a password and returns the password hash in a map.","ref":"Comeonin.html#c:add_hash/2","title":"Comeonin.add_hash/2","type":"callback"},{"doc":"Checks the password by comparing its hash with the password hash found in a user struct, or map.The first argument to check_pass/3 should be a user struct, a regular map, or nil.","ref":"Comeonin.html#c:check_pass/3","title":"Comeonin.check_pass/3","type":"callback"},{"doc":"Runs the password hash function, but always returns false.This function is intended to make it more difficult for any potential attacker to find valid usernames by using timing attacks. This function is only useful if it is used as part of a policy of hiding usernames.","ref":"Comeonin.html#c:no_user_verify/1","title":"Comeonin.no_user_verify/1","type":"callback"},{"doc":"","ref":"Comeonin.html#t:opts/0","title":"Comeonin.opts/0","type":"type"},{"doc":"","ref":"Comeonin.html#t:password/0","title":"Comeonin.password/0","type":"type"},{"doc":"","ref":"Comeonin.html#t:user_struct/0","title":"Comeonin.user_struct/0","type":"type"},{"doc":"Test helper functions for Comeonin behaviours.","ref":"Comeonin.BehaviourTestHelper.html","title":"Comeonin.BehaviourTestHelper","type":"module"},{"doc":"Checks that the add_hash/2 function creates a map with the password_hash set.","ref":"Comeonin.BehaviourTestHelper.html#add_hash_creates_map/2","title":"Comeonin.BehaviourTestHelper.add_hash_creates_map/2","type":"function"},{"doc":"List of passwords that just contain basic ascii characters.","ref":"Comeonin.BehaviourTestHelper.html#ascii_passwords/0","title":"Comeonin.BehaviourTestHelper.ascii_passwords/0","type":"function"},{"doc":"Checks that the check_pass/3 function returns an error when no user is found.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_nil_user/1","title":"Comeonin.BehaviourTestHelper.check_pass_nil_user/1","type":"function"},{"doc":"Checks that the check_pass/3 function returns an error for incorrect passwords.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_error/2","title":"Comeonin.BehaviourTestHelper.check_pass_returns_error/2","type":"function"},{"doc":"Checks that the check_pass/3 function returns the user for correct passwords.","ref":"Comeonin.BehaviourTestHelper.html#check_pass_returns_user/2","title":"Comeonin.BehaviourTestHelper.check_pass_returns_user/2","type":"function"},{"doc":"Checks that the verify_pass/2 function returns true for correct password.","ref":"Comeonin.BehaviourTestHelper.html#correct_password_true/2","title":"Comeonin.BehaviourTestHelper.correct_password_true/2","type":"function"},{"doc":"List of passwords that contain non-ascii characters.","ref":"Comeonin.BehaviourTestHelper.html#non_ascii_passwords/0","title":"Comeonin.BehaviourTestHelper.non_ascii_passwords/0","type":"function"},{"doc":"Checks that the verify_pass/2 function returns false for incorrect passwords.","ref":"Comeonin.BehaviourTestHelper.html#wrong_password_false/2","title":"Comeonin.BehaviourTestHelper.wrong_password_false/2","type":"function"},{"doc":"Defines a behaviour for password hashing functions.","ref":"Comeonin.PasswordHash.html","title":"Comeonin.PasswordHash","type":"behaviour"},{"doc":"Generates a random salt and then hashes the password.","ref":"Comeonin.PasswordHash.html#c:hash_pwd_salt/2","title":"Comeonin.PasswordHash.hash_pwd_salt/2","type":"callback"},{"doc":"Checks the password by comparing it with a stored hash.Please note that the first argument to verify_pass should be the password, and the second argument should be the password hash.","ref":"Comeonin.PasswordHash.html#c:verify_pass/2","title":"Comeonin.PasswordHash.verify_pass/2","type":"callback"},{"doc":"","ref":"Comeonin.PasswordHash.html#t:opts/0","title":"Comeonin.PasswordHash.opts/0","type":"type"},{"doc":"","ref":"Comeonin.PasswordHash.html#t:password/0","title":"Comeonin.PasswordHash.password/0","type":"type"},{"doc":"","ref":"Comeonin.PasswordHash.html#t:password_hash/0","title":"Comeonin.PasswordHash.password_hash/0","type":"type"},{"doc":"Comeonin Comeonin is a specification for password hashing libraries.For information about hashing passwords in your app, see Password hashing libraries.","ref":"readme.html","title":"Comeonin","type":"extras"},{"doc":"In version 5.0 and above, Comeonin now provides two behaviours, Comeonin and Comeonin.PasswordHash, which password hash libraries then implement.With these changes, Comeonin is now a dependency of the password hashing library you choose to use, and in most cases, you will not use it directly.See the UPGRADE_v5 guide for information about you can upgrade to version 5.","ref":"readme.html#changes-in-version-5","title":"Comeonin - Changes in version 5","type":"extras"},{"doc":"The following libraries all implement the Comeonin and Comeonin.PasswordHash behaviours:Argon2 - argon2_elixirdocssourceBcrypt - bcrypt_elixirdocssourcePbkdf2 - pbkdf2_elixirdocssourceArgon2 is currently considered to be the strongest password hashing function, and it is the one we recommend.Bcrypt and Pbkdf2 are viable alternatives, but they are less resistant than Argon2, to attacks using GPUs or dedicated hardware.Windows usersOn Windows, it can be time-consuming and problematic to setup the environment needed to compile the C code in Argon2 and Bcrypt. For this reason, it is often easier to install Pbkdf2, which has no C dependencies.For more information, see Choosing a library.","ref":"readme.html#password-hashing-libraries","title":"Comeonin - Password hashing libraries","type":"extras"},{"doc":"See the Comeonin wiki for more information on the following topics:Hashing passwords - a general guide to hashing passwords in your Elixir appPassword hashing librariesRequirementsDeployment - including information about using DockerReferences","ref":"readme.html#comeonin-wiki","title":"Comeonin - Comeonin wiki","type":"extras"},{"doc":"There are many ways you can contribute to the development of Comeonin, including:Reporting issuesImproving documentationSharing your experiences with othersMaking a financial contribution","ref":"readme.html#contributing","title":"Comeonin - Contributing","type":"extras"},{"doc":"First of all, I would like to emphasize that this software is offered free of charge. However, if you find it useful, and you would like to buy me a cup of coffee, you can do so at PayPal.LicenseBSD. For full details, please read the LICENSE file.","ref":"readme.html#donations","title":"Comeonin - Donations","type":"extras"},{"doc":"Upgrading to version 5In version 5 of Comeonin, in most cases, you will not call Comeonin directly, and so you will be able to remove it from your app.Follow the instructions below to upgrade:Remove :comeonin from the deps function in your mix.exs file.Update :argon2_elixir to version 2.0, :bcrypt_elixir to version 2.0, or :pbkdf2_elixir to version 1.0.Using the conversion tables below, edit the hashing functions.Comeonin v4Comeonin v5Comeonin.Argon2.add_hashArgon2.add_hashComeonin.Argon2.check_passArgon2.check_passComeonin.Argon2.hashpwsaltArgon2.hash_pwd_saltComeonin.Argon2.checkpwArgon2.verify_passComeonin.Argon2.dummy_checkpwArgon2.no_user_verifyComeonin v4Comeonin v5Comeonin.Bcrypt.add_hashBcrypt.add_hashComeonin.Bcrypt.check_passBcrypt.check_passComeonin.Bcrypt.hashpwsaltBcrypt.hash_pwd_saltComeonin.Bcrypt.checkpwBcrypt.verify_passComeonin.Bcrypt.dummy_checkpwBcrypt.no_user_verifyComeonin v4Comeonin v5Comeonin.Pbkdf2.add_hashPbkdf2.add_hashComeonin.Pbkdf2.check_passPbkdf2.check_passComeonin.Pbkdf2.hashpwsaltPbkdf2.hash_pwd_saltComeonin.Pbkdf2.checkpwPbkdf2.verify_passComeonin.Pbkdf2.dummy_checkpwPbkdf2.no_user_verify","ref":"upgrade_v5.html","title":"Upgrading to version 5","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changeschanged add_hash so that it does NOT set the password to nil","ref":"changelog.html#5-3-0","title":"Changelog - 5.3.0","type":"extras"},{"doc":"Enhancementsupdated documentation for the Comeonin module","ref":"changelog.html#5-2-0","title":"Changelog - 5.2.0","type":"extras"},{"doc":"Enhancementsadd a behaviour_test module to be used by implementations of the Comeonin behaviours","ref":"changelog.html#5-1-0","title":"Changelog - 5.1.0","type":"extras"},{"doc":"Enhancementsupdated Comeonin to be a specification for password hashing librariesit offers the Comeonin and Comeonin.PasswordHash behaviours","ref":"changelog.html#5-0-0","title":"Changelog - 5.0.0","type":"extras"},{"doc":"Bug fixesmade sure that the hash_key option is used if present","ref":"changelog.html#4-1-2","title":"Changelog - 4.1.2","type":"extras"},{"doc":"Changeschanged check_pass with statement to case - in an attempt to suppress dialyzer warnings","ref":"changelog.html#4-1-1","title":"Changelog - 4.1.1","type":"extras"},{"doc":"Enhancementsadded hash_key option to check_passas with version 4.0, check_pass will use :password_hash / :encrypted_password if present","ref":"changelog.html#4-1-0","title":"Changelog - 4.1.0","type":"extras"},{"doc":"EnhancementsAdded support for Argon2 (as an optional dependency - argon2_elixir)Added higher-level helper functions to each algorithm's moduleThese functions accept / return maps and should reduce code use when adding password hashes / checking passwordsImproved the statistics function in each module - reportChangesMade all the hashing algorithms optional dependenciesMoved the configuration to the separate dependency librariesRemoved support for one-time passwordsThis is now a separate library - OneTimePassEcto (&quot;https://github.com/riverrun/one_time_pass_ecto&quot;)","ref":"changelog.html#4-0-0","title":"Changelog - 4.0.0","type":"extras"},{"doc":"Bug fixesShortening user-supplied salts to 128 bits - making it compatible with other implementations","ref":"changelog.html#3-2-0","title":"Changelog - 3.2.0","type":"extras"},{"doc":"ChangesNow forcing a recompile of C code for Windows users","ref":"changelog.html#3-1-0","title":"Changelog - 3.1.0","type":"extras"},{"doc":"EnhancementsSmall changes to NIF code to make it more scheduler-friendlyImproved documentation with respect to Argon2ChangesNow using elixir_make to help compile the C code","ref":"changelog.html#3-0-0","title":"Changelog - 3.0.0","type":"extras"},{"doc":"EnhancementsImproved Windows build to prevent build failure when upgrading Erlang versions","ref":"changelog.html#2-6-0","title":"Changelog - 2.6.0","type":"extras"},{"doc":"EnhancementsImproved Windows build error messagesChangesChanged behavior for incorrect input to Bcrypt.gen_salt","ref":"changelog.html#2-4-0","title":"Changelog - 2.4.0","type":"extras"},{"doc":"EnhancementsAdded support for one-time passwords (HOTP, TOTP) for use in two factor authentication","ref":"changelog.html#2-3-0","title":"Changelog - 2.3.0","type":"extras"},{"doc":"ChangesImproved documentation for Windows buildsUpdated the required Elixir version to 1.2","ref":"changelog.html#2-2-0","title":"Changelog - 2.2.0","type":"extras"},{"doc":"EnhancementsAdded legacy option to Comeonin.Bcrypt.gen_salt so that hashes with the older $2a$ prefix can be more easily generatedTo try to solve the load errors after upgrading Erlang / Elixir:Force C code to be recompiled every time deps.compile is calledAdded basic upgrade function to the NIF libraryTo be compatible with the nerves project:Added CROSSCOMPILE option to the MakefileStopped the library autoloading on compilation (requires Elixir 1.2.2)","ref":"changelog.html#2-1-0","title":"Changelog - 2.1.0","type":"extras"},{"doc":"ChangesIncreased the default number of rounds for pbkdf2_sha512 to 100_000Removed create_hash and create_user functionsMoved the password strength checker and random password generator to a separate package, called NotQwerty123This means that i18n support has been moved to NotQwerty123","ref":"changelog.html#2-0-0-2015-12-17","title":"Changelog - 2.0.0 (2015-12-17)","type":"extras"},{"doc":"ChangesEdited C code and deleted unused functions","ref":"changelog.html#1-6-0-2015-11-17","title":"Changelog - 1.6.0 (2015-11-17)","type":"extras"},{"doc":"ChangesMoved gettext support to comeonin_i18n optional dependencyRemoved forced compilation of C code in dev and prod environments","ref":"changelog.html#1-5-0-2015-11-10","title":"Changelog - 1.5.0 (2015-11-10)","type":"extras"},{"doc":"EnhancementsAdded gettext supportAdded Japanese translations for messages","ref":"changelog.html#1-4-0-2015-11-06","title":"Changelog - 1.4.0 (2015-11-06)","type":"extras"},{"doc":"EnhancementsImproved the efficiency of the common password check for the strong_password functionAdded more information to the Mix build errorsChangesForcing compilation of C code in dev and prod environments","ref":"changelog.html#1-3-0-2015-10-18","title":"Changelog - 1.3.0 (2015-10-18)","type":"extras"},{"doc":"EnhancementsAdded a common option to the strong_password check. This checks for passwords that are easy to guess, or commonImproved random password generator - added a check to ensure it is strong and set the minimum length to 8 characters","ref":"changelog.html#1-2-0-2015-09-26","title":"Changelog - 1.2.0 (2015-09-26)","type":"extras"},{"doc":"Bug fixRemoved random_bytes function. Now calling :crypto.strong_rand_bytes directly","ref":"changelog.html#1-1-4-2015-09-25","title":"Changelog - 1.1.4 (2015-09-25)","type":"extras"},{"doc":"ChangesDivided the strong password check into two parts: minimum length and check for punctuation characters and digitsRemoved configuration values for password length for generated passwords and minimum length of passwords for the password check","ref":"changelog.html#1-1-0-2015-07-28","title":"Changelog - 1.1.0 (2015-07-28)","type":"extras"},{"doc":"Bug fixReplaced Mix.Shell.info with IO.binwrite to prevent compile errors with certain character encodings","ref":"changelog.html#1-0-5-2015-07-14","title":"Changelog - 1.0.5 (2015-07-14)","type":"extras"},{"doc":"EnhancementsEnabled the create_user function to be used with atoms as keys as well as strings","ref":"changelog.html#1-0-1-2015-05-31","title":"Changelog - 1.0.1 (2015-05-31)","type":"extras"},{"doc":"ChangesRenamed signup_user, function to check password strength before hashing the password, to create_userEnhancementsAdded create_user function which takes a map, removes the &quot;password&quot; entry and adds a &quot;password_hash&quot; entry","ref":"changelog.html#1-0-0-2015-05-20","title":"Changelog - 1.0.0 (2015-05-20)","type":"extras"},{"doc":"ChangesRenamed hashpwsalt/2 to signup_user/1","ref":"changelog.html#0-11-0-2015-05-19","title":"Changelog - 0.11.0 (2015-05-19)","type":"extras"},{"doc":"ChangesRemoved log_rounds, or rounds, parameter for the function hashpwsaltAdded option to check password (for strength) in the function hashpwsalt (hashpwsalt/2)","ref":"changelog.html#0-10-0-2015-05-14","title":"Changelog - 0.10.0 (2015-05-14)","type":"extras"},{"doc":"EnhancementsAdded random password generatorAdded optional check to test if passwords have digits and punctuation charactersBug fixesAdded information about password strength and password policies to the documentation","ref":"changelog.html#0-9-0-2015-05-08","title":"Changelog - 0.9.0 (2015-05-08)","type":"extras"},{"doc":"Bug fixesUpdated Windows build and improved error information at compile time","ref":"changelog.html#0-8-2-2015-05-02","title":"Changelog - 0.8.2 (2015-05-02)","type":"extras"},{"doc":"Bug fixesUpdated bcrypt to support non-ascii characters in the password (pbkdf2 already supports these characters)","ref":"changelog.html#0-8-0-2015-04-20","title":"Changelog - 0.8.0 (2015-04-20)","type":"extras"},{"doc":"EnhancementsUse crypto.strong_rand_bytes by default for generating random numbers","ref":"changelog.html#0-7-0-2015-04-18","title":"Changelog - 0.7.0 (2015-04-18)","type":"extras"},{"doc":"EnhancementsUpdated bcrypt implementation to only call C functions for the most expensive operations","ref":"changelog.html#0-6-0-2015-04-17","title":"Changelog - 0.6.0 (2015-04-17)","type":"extras"},{"doc":"EnhancementsUpdated bcrypt implementation so that long-running NIFs are cut to a minimum","ref":"changelog.html#0-5-0-2015-04-14","title":"Changelog - 0.5.0 (2015-04-14)","type":"extras"},{"doc":"EnhancementsUpdated pbkdf2_sha512 to prevent users from calling hashpass without a salt","ref":"changelog.html#0-4-0-2015-04-05","title":"Changelog - 0.4.0 (2015-04-05)","type":"extras"},{"doc":"EnhancementsUpdated bcrypt to version 1.5.2","ref":"changelog.html#0-3-0-2015-03-04","title":"Changelog - 0.3.0 (2015-03-04)","type":"extras"},{"doc":"EnhancementsAdded configuration options for number of log_rounds, or rounds","ref":"changelog.html#v0-2-4-2015-02-26","title":"Changelog - v0.2.4 (2015-02-26)","type":"extras"},{"doc":"EnhancementsImproved documentation about the recommended time the functions should takeIncreased default number of rounds for pbkdf2_sha512 from 40000 to 60000Improved implementation of dummy checkChangesRemoved the salt_length optional argument from Comeonin.Pbkdf2.hashpwsalt. The only optional argument to this function is now the number of rounds","ref":"changelog.html#v0-2-2-2015-01-25","title":"Changelog - v0.2.2 (2015-01-25)","type":"extras"},{"doc":"EnhancementsAdded support for pbkdf2_sha512Added Travis integrationAdded timing functions to help developers adjust the complexity of the key derivation functionsChangesRemoved the hashing and check functions from the main Comeonin module","ref":"changelog.html#v0-2-0-2015-01-21","title":"Changelog - v0.2.0 (2015-01-21)","type":"extras"},{"doc":"Bug fixesEnable build on OS X","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Bcrypt authentication","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]